Index: /LMDZ5/branches/testing/libf/phylmd/YOETHF.h
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/YOETHF.h	(revision 2055)
+++ /LMDZ5/branches/testing/libf/phylmd/YOETHF.h	(revision 2056)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
 !  ATTENTION!!!!: ce fichier include est compatible format fixe/format libre
@@ -17,5 +17,12 @@
       REAL R2ES, R3LES, R3IES, R4LES, R4IES, R5LES, R5IES
       REAL RVTMP2, RHOH2O
+      REAL R5ALVCP,R5ALSCP,RALVDCP,RALSDCP,RALFDCP,RTWAT,RTBER,RTBERCU
+      REAL RTICE,RTICECU,RTWAT_RTICE_R,RTWAT_RTICECU_R,RKOOP1,RKOOP2
       COMMON /YOETHF/R2ES, R3LES, R3IES, R4LES, R4IES, R5LES, R5IES,    &
-     &               RVTMP2, RHOH2O
+     &               RVTMP2, RHOH2O,                                    &
+     &               R5ALVCP,R5ALSCP,RALVDCP,RALSDCP,                   &
+     &               RALFDCP,RTWAT,RTBER,RTBERCU,                       &
+     &               RTICE,RTICECU,RTWAT_RTICE_R,RTWAT_RTICECU_R,RKOOP1,&
+     &	  	     RKOOP2
+
 !$OMP THREADPRIVATE(/YOETHF/)
Index: /LMDZ5/branches/testing/libf/phylmd/add_pbl_tend.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/add_pbl_tend.F90	(revision 2055)
+++ /LMDZ5/branches/testing/libf/phylmd/add_pbl_tend.F90	(revision 2056)
@@ -1,3 +1,3 @@
-SUBROUTINE add_pbl_tend(zdu, zdv, zdt, zdq, zdql, text)
+SUBROUTINE add_pbl_tend(zdu, zdv, zdt, zdq, zdql, paprs, text)
   ! ======================================================================
   ! Ajoute les tendances de couche limite, soit determinees par la
@@ -29,4 +29,5 @@
   REAL zdt(klon, klev), zdq(klon, klev), zdql(klon, klev)
   CHARACTER *(*) text
+  REAL paprs(klon,klev+1)
 
   ! Local :
@@ -45,7 +46,7 @@
     PRINT *, ' add_pbl_tend, zzdt ', zzdt
     PRINT *, ' add_pbl_tend, zzdq ', zzdq
-    CALL add_phys_tend(zdu, zdv, zzdt, zzdq, zdql, text)
+    CALL add_phys_tend(zdu, zdv, zzdt, zzdq, zdql, paprs, text)
   ELSE
-    CALL add_phys_tend(zdu, zdv, zdt, zdq, zdql, text)
+    CALL add_phys_tend(zdu, zdv, zdt, zdq, zdql, paprs, text)
   END IF
 
Index: /LMDZ5/branches/testing/libf/phylmd/add_phys_tend.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/add_phys_tend.F90	(revision 2055)
+++ /LMDZ5/branches/testing/libf/phylmd/add_phys_tend.F90	(revision 2056)
@@ -2,5 +2,5 @@
 ! $Id$
 !
-SUBROUTINE add_phys_tend (zdu,zdv,zdt,zdq,zdql,text)
+SUBROUTINE add_phys_tend (zdu,zdv,zdt,zdq,zdql,paprs,text)
 !======================================================================
 ! Ajoute les tendances des variables physiques aux variables 
@@ -18,5 +18,7 @@
 use phys_state_var_mod
 IMPLICIT none
-#include "iniprint.h"
+  include "iniprint.h"
+  include "YOMCST.h"
+  include "clesphys.h"
 
 ! Arguments :
@@ -24,4 +26,5 @@
 REAL zdu(klon,klev),zdv(klon,klev)
 REAL zdt(klon,klev),zdq(klon,klev),zdql(klon,klev)
+REAL paprs(klon,klev+1)
 CHARACTER*(*) text
 
@@ -29,4 +32,7 @@
 !--------
 REAL zt,zq
+REAL zq_int, zqp_int, zq_new
+
+REAL zqp(klev)
 
 INTEGER i, k,j
@@ -35,4 +41,6 @@
 INTEGER kadrs(klon*klev)
 INTEGER kqadrs(klon*klev)
+
+LOGICAL done(klon)
 
 integer debug_level
@@ -107,27 +115,59 @@
 !=====================================================================================
 IF (jqbad .GT. 0) THEN
+      done(:) = .false.                         !jyg
       DO j = 1, jqbad
-         i=jqadrs(j)
-         if(prt_level.ge.debug_level) THEN
-          print*,'WARNING  : EAU POUR LE POINT i rlon rlat =',i,rlon(i),rlat(i),text
-          print*,'l    T     dT       Q     dQ    '
-         endif
-         DO k = 1, klev
-           zq=q_seri(i,k)+zdq(i,k)
-           if (zq.lt.1.e-15) then
-              if (q_seri(i,k).lt.1.e-15) then
-               if(prt_level.ge.debug_level) THEN
-                print*,' cas q_seri<1.e-15 i k q_seri zq zdq :',i,k,q_seri(i,k),zq,zdq(i,k)
-               endif
-               q_seri(i,k)=1.e-15
-               zdq(i,k)=(1.e-15-q_seri(i,k))
+        i=jqadrs(j)
+          if(prt_level.ge.debug_level) THEN
+           print*,'WARNING  : EAU POUR LE POINT i rlon rlat =',i,rlon(i),rlat(i),text
+           print*,'l    T     dT       Q     dQ    '
+           DO k = 1, klev
+              write(*,'(i3,2f14.4,2e14.2)') k,t_seri(i,k),zdt(i,k),q_seri(i,k),zdq(i,k)
+           ENDDO
+          endif
+          IF (ok_conserv_q) THEN
+!jyg<20140228 Corrections pour conservation de l'eau
+            IF (.NOT.done(i)) THEN                  !jyg
+              DO k = 1, klev
+                zqp(k) = max(q_seri(i,k),1.e-15)
+              ENDDO
+              zq_int  = 0.
+              zqp_int = 0.
+              DO k = 1, klev
+                zq_int  = zq_int  + q_seri(i,k)*(paprs(i,k)-paprs(i,k+1))/Rg
+                zqp_int = zqp_int + zqp(k)     *(paprs(i,k)-paprs(i,k+1))/Rg
+              ENDDO
+              if(prt_level.ge.debug_level) THEN
+               print*,' cas q_seri<1.e-15 i k zq_int zqp_int zq_int/zqp_int :', &
+                                    i, kqadrs(j), zq_int, zqp_int, zq_int/zqp_int
               endif
-           endif
-!           zq=q_seri(i,k)+zdq(i,k)
-!           if (zq.lt.1.e-15) then
-!              zdq(i,k)=(1.e-15-q_seri(i,k))
-!           endif
-         ENDDO
-      ENDDO
+              DO k = 1, klev
+                zq_new = zqp(k)*zq_int/zqp_int
+                zdq(i,k) = zdq(i,k) + zq_new - q_seri(i,k)
+                q_seri(i,k) = zq_new
+              ENDDO
+              done(i) = .true.
+            ENDIF !(.NOT.done(i))
+          ELSE 
+!jyg>
+            DO k = 1, klev
+              zq=q_seri(i,k)+zdq(i,k)
+              if (zq.lt.1.e-15) then
+                 if (q_seri(i,k).lt.1.e-15) then
+                  if(prt_level.ge.debug_level) THEN
+                   print*,' cas q_seri<1.e-15 i k q_seri zq zdq :',i,k,q_seri(i,k),zq,zdq(i,k)
+                  endif
+                  q_seri(i,k)=1.e-15
+                  zdq(i,k)=(1.e-15-q_seri(i,k))
+                 endif
+              endif
+!              zq=q_seri(i,k)+zdq(i,k)
+!              if (zq.lt.1.e-15) then
+!                 zdq(i,k)=(1.e-15-q_seri(i,k))
+!              endif
+            ENDDO
+!jyg<20140228
+          ENDIF   !  (ok_conserv_q)
+!jyg>
+      ENDDO ! j = 1, jqbad
 ENDIF
 !
Index: /LMDZ5/branches/testing/libf/phylmd/aero_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/aero_mod.F90	(revision 2055)
+++ /LMDZ5/branches/testing/libf/phylmd/aero_mod.F90	(revision 2056)
@@ -2,13 +2,13 @@
 !
 MODULE aero_mod
-  ! Declaration des indices pour les aerosols 
+! Declaration des indices pour les aerosols 
 
-  ! Total number of aerosols
-!  INTEGER, PARAMETER :: naero_tot = 10 
-!--STRAT AER
+! 1/ Total number of aerosols for which an aerosol optical depth is provided
+!--strat aerosols are only prescribed naero_tot = 10 ==> 11 
+
   INTEGER, PARAMETER :: naero_tot = 11
 
-  ! Identification number used in aeropt_2bands and aeropt_5wv
-  ! corresponding to naero_tot
+! Identification number used in aeropt_2bands and aeropt_5wv
+! corresponding to naero_tot
   INTEGER, PARAMETER :: id_ASBCM    = 1
   INTEGER, PARAMETER :: id_ASPOMM   = 2
@@ -21,25 +21,25 @@
   INTEGER, PARAMETER :: id_AIBCM    = 9
   INTEGER, PARAMETER :: id_AIPOMM   = 10
-!--STRAT AER
-  INTEGER, PARAMETER :: id_strat   = 11
+  INTEGER, PARAMETER :: id_STRAT   = 11
 
+! Corresponding names for the aerosols
+  CHARACTER(len=7),DIMENSION(naero_tot), PARAMETER :: name_aero_tau=(/&
+       "ASBCM  ", &
+       "ASPOMM ", &
+       "SO4    ", &
+       "CSSO4M ", &
+       "SSSSM  ", &
+       "CSSSM  ", &
+       "ASSSM  ", &
+       "CIDUSTM", &
+       "AIBCM  ", &
+       "AIPOMM ", &
+       "STRAT  " /)
 
-  ! Total number of aerosols actually used in LMDZ 
-  ! 1 =  ASBCM
-  ! 2 =  ASPOMM
-  ! 3 =  ASSO4M ( = SO4) 
-  ! 4 =  CSSO4M 
-  ! 5 =  SSSSM 
-  ! 6 =  CSSSM
-  ! 7 =  ASSSM
-  ! 8 =  CIDUSTM
-  ! 9 =  AIBCM
-  !10 =  AIPOMM
-!--STRAT AER
-  !11 = aerosols stratos
-!  INTEGER, PARAMETER :: naero_spc = 10
-  INTEGER, PARAMETER :: naero_spc = 11
+! 2/ Total number of aerosols for which an aerosol mass is provided
 
-  ! Corresponding names for the aerosols
+  INTEGER, PARAMETER :: naero_spc = 10
+
+! Corresponding names for the aerosols
   CHARACTER(len=7),DIMENSION(naero_spc), PARAMETER :: name_aero=(/&
        "ASBCM  ", &
@@ -52,10 +52,8 @@
        "CIDUSTM", &
        "AIBCM  ", &
-!       "AIPOMM " /)
-       "AIPOMM ", &
-       "STRAT  " /)
+       "AIPOMM " /)
 
-
-  ! Number of aerosol groups
+! 3/ Number of aerosol groups
+  INTEGER, PARAMETER :: naero_grp = 9 
   ! 1 = ZERO    
   ! 2 = AER total    
@@ -67,11 +65,11 @@
   ! 8 = SS    
   ! 9 = NO3    
-  INTEGER, PARAMETER :: naero_grp = 9 
 
-  ! Number of  wavelengths
+! Number of  wavelengths
   INTEGER, PARAMETER :: nwave = 5
 
-  ! Number of modes spectral bands
+! Number of modes spectral bands
   INTEGER, parameter :: nbands = 2
+  INTEGER, parameter :: nbands_rrtm = 6
 
 END MODULE aero_mod
Index: /LMDZ5/branches/testing/libf/phylmd/aeropt_2bands.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/aeropt_2bands.F90	(revision 2055)
+++ /LMDZ5/branches/testing/libf/phylmd/aeropt_2bands.F90	(revision 2056)
@@ -928,5 +928,7 @@
     ENDDO  ! nb_aer  
 
-  DO m=1,nb_aer   
+!correction bug OB
+!  DO m=1,nb_aer   
+  DO m=1,naero_tot   
     IF (.NOT. used_aer(m)) THEN
       tau_ae(:,:,m,:)=0.
Index: /LMDZ5/branches/testing/libf/phylmd/clesphys.h
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/clesphys.h	(revision 2055)
+++ /LMDZ5/branches/testing/libf/phylmd/clesphys.h	(revision 2056)
@@ -76,4 +76,5 @@
        LOGICAL :: ok_strato
        LOGICAL :: ok_hines, ok_gwd_rando
+       LOGICAL :: ok_conserv_q
 
        COMMON/clesphys/                                                 &
@@ -113,5 +114,6 @@
      &     , ok_lic_melt,           aer_type                            &
      &     , iflag_rrtm, ok_strato,ok_hines                             &
-     &     , iflag_ice_thermo, ok_gwd_rando, NSW
+     &     , iflag_ice_thermo, ok_gwd_rando, NSW                        &
+     &     , ok_conserv_q
      
        save /clesphys/
Index: /LMDZ5/branches/testing/libf/phylmd/coefcdrag.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/coefcdrag.F90	(revision 2055)
+++ /LMDZ5/branches/testing/libf/phylmd/coefcdrag.F90	(revision 2056)
@@ -52,4 +52,5 @@
       include "YOMCST.h"
       include "YOETHF.h"
+      INCLUDE "clesphys.h"
 ! Quelques constantes :
       REAL, parameter :: RKAR=0.40, CB=5.0, CC=5.0, CD=5.0, cepdu2=(0.1)**2
@@ -75,9 +76,11 @@
                  (1.+ RETV * max(q(i),0.0))))
        ztsolv(i) = ts(i)
-       ztvd(i) = t(i) * (psol(i)/pref(i))**RKAPPA
+!       ztvd(i) = t(i) * (psol(i)/pref(i))**RKAPPA
+       ztvd(i) = (t(i)+zdphi(i)/RCPD/(1.+RVTMP2*q(i))) &
+          *(1.+RETV*q(i))
        trm0(i) = 1. + RETV * max(qsurf(i),0.0)
        trm1(i) = 1. + RETV * max(q(i),0.0)
        ztsolv(i) = ztsolv(i) * trm0(i)
-       ztvd(i) = ztvd(i) * trm1(i)
+!       ztvd(i) = ztvd(i) * trm1(i)
        zri1(i) = zdphi(i)*(ztvd(i)-ztsolv(i))/(zdu2(i)*ztvd(i))
 !
@@ -110,5 +113,7 @@
            zcfm1(i) = cdran(i) * friv(i)
            frih(i) = max(1./ (1.+3.*CB*zri1(i)*zscf(i)), 0.1 )
-           zcfh1(i) = cdran(i) * frih(i)
+!           zcfh1(i) = cdran(i) * frih(i)
+           zcfh1(i) = f_cdrag_ter*cdran(i) * frih(i)
+           IF(nsrf.EQ.is_oce) zcfh1(i)=f_cdrag_oce*cdran(i)*frih(i)
            cdram(i) = zcfm1(i)
            cdrah(i) = zcfh1(i)
@@ -126,5 +131,6 @@
                  *(1.0+zdphi(i)/(RG*rugos(i)))))
            zcfm2(i) = cdran(i)*max((1.-2.0*CB*zri1(i)*zucf(i)),0.1)
-           zcfh2(i) = cdran(i)*max((1.-3.0*CB*zri1(i)*zucf(i)),0.1)
+!           zcfh2(i) = cdran(i)*max((1.-3.0*CB*zri1(i)*zucf(i)),0.1)
+           zcfh2(i) = f_cdrag_ter*cdran(i)*max((1.-3.0*CB*zri1(i)*zucf(i)),0.1)
            cdram(i) = zcfm2(i)
            cdrah(i) = zcfh2(i)
@@ -138,5 +144,7 @@
          zcr(i) = (0.0016/(cdran(i)*SQRT(zdu2(i))))*ABS(ztvd(i)-ztsolv(i)) &
                **(1./3.)
-         IF (nsrf.EQ.is_oce) cdrah(i) = cdran(i)*(1.0+zcr(i)**1.25) &
+!         IF (nsrf.EQ.is_oce) cdrah(i) = cdran(i)*(1.0+zcr(i)**1.25) &
+!                  **(1./1.25)
+         IF (nsrf.EQ.is_oce) cdrah(i)=f_cdrag_oce*cdran(i)*(1.0+zcr(i)**1.25) &
                   **(1./1.25)
        ENDIF
Index: /LMDZ5/branches/testing/libf/phylmd/compar1d.h
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/compar1d.h	(revision 2056)
+++ /LMDZ5/branches/testing/libf/phylmd/compar1d.h	(revision 2056)
@@ -0,0 +1,46 @@
+!
+! $Id: compar1d.h 2010-08-04 17:02:56Z lahellec $
+!
+      integer :: forcing_type
+      real :: nat_surf
+      real :: tsurf
+      real :: rugos
+      real :: qsol(1:2)
+      real :: qsurf
+      real :: psurf
+      real :: zsurf
+      real :: albedo
+
+      real :: time
+      real :: time_ini
+      real :: xlat 
+      real :: xlon 
+      real :: airefi
+      real :: wtsurf 
+      real :: wqsurf 
+      real :: restart_runoff 
+      real :: xagesno 
+      real :: qsolinp 
+      real :: zpicinp 
+
+      logical :: restart
+      logical :: ok_old_disvert
+
+      common/com_par1d/                                                 &
+     & nat_surf,tsurf,rugos,                                            &
+     & qsol,qsurf,psurf,zsurf,albedo,time,time_ini,xlat,xlon,airefi,    &
+     & wtsurf,wqsurf,restart_runoff,xagesno,qsolinp,zpicinp,            &
+     & forcing_type,                                                    &
+     & restart,ok_old_disvert
+
+!$OMP THREADPRIVATE(/com_par1d/)
+
+
+
+
+
+
+
+
+
+
